// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.batch.denormalized;

import fr.ifremer.adagio.core.dao.data.operation.Operation;
import fr.ifremer.adagio.core.dao.data.survey.sale.Sale;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.Method;
import fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * ATTENTION : Table technique. (RAZ des données possible)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DenormalizedBatch
    implements Serializable, Comparable<DenormalizedBatch>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -5440393083789243729L;

    // Generate 24 attributes
    private Long id;

    /**
     * Identifiant unique du lot.
     * Même identifiant que le lot de la table BATCH correspondant : pas de numérotation
     * automatique.
     * @return this.id Long
     */
    public Long getId()
    {
        return this.id;
    }

    /**
     * Identifiant unique du lot.
     * Même identifiant que le lot de la table BATCH correspondant : pas de numérotation
     * automatique.
     * @param idIn Long
     */
    public void setId(Long idIn)
    {
        this.id = idIn;
    }

    private Short rankOrder;

    /**
     * 
     * @return this.rankOrder Short
     */
    public Short getRankOrder()
    {
        return this.rankOrder;
    }

    /**
     * 
     * @param rankOrderIn Short
     */
    public void setRankOrder(Short rankOrderIn)
    {
        this.rankOrder = rankOrderIn;
    }

    private Short flatRankOrder;

    /**
     * 
     * @return this.flatRankOrder Short
     */
    public Short getFlatRankOrder()
    {
        return this.flatRankOrder;
    }

    /**
     * 
     * @param flatRankOrderIn Short
     */
    public void setFlatRankOrder(Short flatRankOrderIn)
    {
        this.flatRankOrder = flatRankOrderIn;
    }

    private Float weight;

    /**
     * 
     * @return this.weight Float
     */
    public Float getWeight()
    {
        return this.weight;
    }

    /**
     * 
     * @param weightIn Float
     */
    public void setWeight(Float weightIn)
    {
        this.weight = weightIn;
    }

    private Float indirectWeight;

    /**
     * 
     * @return this.indirectWeight Float
     */
    public Float getIndirectWeight()
    {
        return this.indirectWeight;
    }

    /**
     * 
     * @param indirectWeightIn Float
     */
    public void setIndirectWeight(Float indirectWeightIn)
    {
        this.indirectWeight = indirectWeightIn;
    }

    private Float elevateWeight;

    /**
     * 
     * @return this.elevateWeight Float
     */
    public Float getElevateWeight()
    {
        return this.elevateWeight;
    }

    /**
     * 
     * @param elevateWeightIn Float
     */
    public void setElevateWeight(Float elevateWeightIn)
    {
        this.elevateWeight = elevateWeightIn;
    }

    private Integer individualCount;

    /**
     * 
     * @return this.individualCount Integer
     */
    public Integer getIndividualCount()
    {
        return this.individualCount;
    }

    /**
     * 
     * @param individualCountIn Integer
     */
    public void setIndividualCount(Integer individualCountIn)
    {
        this.individualCount = individualCountIn;
    }

    private Integer indirectIndividualCount;

    /**
     * 
     * @return this.indirectIndividualCount Integer
     */
    public Integer getIndirectIndividualCount()
    {
        return this.indirectIndividualCount;
    }

    /**
     * 
     * @param indirectIndividualCountIn Integer
     */
    public void setIndirectIndividualCount(Integer indirectIndividualCountIn)
    {
        this.indirectIndividualCount = indirectIndividualCountIn;
    }

    private Integer elevateIndividualCount;

    /**
     * 
     * @return this.elevateIndividualCount Integer
     */
    public Integer getElevateIndividualCount()
    {
        return this.elevateIndividualCount;
    }

    /**
     * 
     * @param elevateIndividualCountIn Integer
     */
    public void setElevateIndividualCount(Integer elevateIndividualCountIn)
    {
        this.elevateIndividualCount = elevateIndividualCountIn;
    }

    private Float elevateContextWeight;

    /**
     * Poids élevé du lot, dans le même contexte que lors de l'observation (contrairement à
     * elevateWeight qui est l'élévation de l'équivalent poids vif et plein).
     * Calculé par le traitement de dénormalisation.
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids indirect des lots
     * fils utilisé ou non. Le choix de la méthode de calcul dépend de l'exhaustiivité de
     * l'inventaire, des taux d'échantillonnage, des éventuels lots fraction, etc.
     * Le poids indirect ne peut pas être utilisé pour ce champ si les fils ne sont pas de même
     * présentation/état.
     * Evolutions mantis liées :
     * - #13524 (et discussion thématique #13376).
     * @return this.elevateContextWeight Float
     */
    public Float getElevateContextWeight()
    {
        return this.elevateContextWeight;
    }

    /**
     * Poids élevé du lot, dans le même contexte que lors de l'observation (contrairement à
     * elevateWeight qui est l'élévation de l'équivalent poids vif et plein).
     * Calculé par le traitement de dénormalisation.
     * Suivant les cas, les taux d'échantillonnage ont été appliqués, le poids indirect des lots
     * fils utilisé ou non. Le choix de la méthode de calcul dépend de l'exhaustiivité de
     * l'inventaire, des taux d'échantillonnage, des éventuels lots fraction, etc.
     * Le poids indirect ne peut pas être utilisé pour ce champ si les fils ne sont pas de même
     * présentation/état.
     * Evolutions mantis liées :
     * - #13524 (et discussion thématique #13376).
     * @param elevateContextWeightIn Float
     */
    public void setElevateContextWeight(Float elevateContextWeightIn)
    {
        this.elevateContextWeight = elevateContextWeightIn;
    }

    private Float indirectContextWeight;

    /**
     * Poids contextuel indirect (need for Allegro (cf mantis #17728)
     * @return this.indirectContextWeight Float
     */
    public Float getIndirectContextWeight()
    {
        return this.indirectContextWeight;
    }

    /**
     * Poids contextuel indirect (need for Allegro (cf mantis #17728)
     * @param indirectContextWeightIn Float
     */
    public void setIndirectContextWeight(Float indirectContextWeightIn)
    {
        this.indirectContextWeight = indirectContextWeightIn;
    }

    private Float samplingRatio;

    /**
     * 
     * @return this.samplingRatio Float
     */
    public Float getSamplingRatio()
    {
        return this.samplingRatio;
    }

    /**
     * 
     * @param samplingRatioIn Float
     */
    public void setSamplingRatio(Float samplingRatioIn)
    {
        this.samplingRatio = samplingRatioIn;
    }

    private String samplingRatioText;

    /**
     * 
     * @return this.samplingRatioText String
     */
    public String getSamplingRatioText()
    {
        return this.samplingRatioText;
    }

    /**
     * 
     * @param samplingRatioTextIn String
     */
    public void setSamplingRatioText(String samplingRatioTextIn)
    {
        this.samplingRatioText = samplingRatioTextIn;
    }

    private Boolean exhaustiveInventory;

    /**
     * 
     * @return this.exhaustiveInventory Boolean
     */
    public Boolean getExhaustiveInventory()
    {
        return this.exhaustiveInventory;
    }

    /**
     * 
     * @param exhaustiveInventoryIn Boolean
     */
    public void setExhaustiveInventory(Boolean exhaustiveInventoryIn)
    {
        this.exhaustiveInventory = exhaustiveInventoryIn;
    }

    private Boolean childBatchsReplication;

    /**
     * 
     * @return this.childBatchsReplication Boolean
     */
    public Boolean getChildBatchsReplication()
    {
        return this.childBatchsReplication;
    }

    /**
     * 
     * @param childBatchsReplicationIn Boolean
     */
    public void setChildBatchsReplication(Boolean childBatchsReplicationIn)
    {
        this.childBatchsReplication = childBatchsReplicationIn;
    }

    private String comments;

    /**
     * 
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * 
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Short treeLevel;

    /**
     * 
     * @return this.treeLevel Short
     */
    public Short getTreeLevel()
    {
        return this.treeLevel;
    }

    /**
     * 
     * @param treeLevelIn Short
     */
    public void setTreeLevel(Short treeLevelIn)
    {
        this.treeLevel = treeLevelIn;
    }

    private String treeIndent;

    /**
     * 
     * @return this.treeIndent String
     */
    public String getTreeIndent()
    {
        return this.treeIndent;
    }

    /**
     * 
     * @param treeIndentIn String
     */
    public void setTreeIndent(String treeIndentIn)
    {
        this.treeIndent = treeIndentIn;
    }

    private String sortingValuesText;

    /**
     * 
     * @return this.sortingValuesText String
     */
    public String getSortingValuesText()
    {
        return this.sortingValuesText;
    }

    /**
     * 
     * @param sortingValuesTextIn String
     */
    public void setSortingValuesText(String sortingValuesTextIn)
    {
        this.sortingValuesText = sortingValuesTextIn;
    }

    private Boolean isLanding;

    /**
     * 
     * @return this.isLanding Boolean
     */
    public Boolean isIsLanding()
    {
        return this.isLanding;
    }

    /**
     * 
     * @param isLandingIn Boolean
     */
    public void setIsLanding(Boolean isLandingIn)
    {
        this.isLanding = isLandingIn;
    }

    private Boolean isDiscard;

    /**
     * 
     * @return this.isDiscard Boolean
     */
    public Boolean isIsDiscard()
    {
        return this.isDiscard;
    }

    /**
     * 
     * @param isDiscardIn Boolean
     */
    public void setIsDiscard(Boolean isDiscardIn)
    {
        this.isDiscard = isDiscardIn;
    }

    private Timestamp updateDate;

    /**
     * Date de dernière mis à jour.
     * Champ technique mise à jour automatiquement (par trigger)
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * Date de dernière mis à jour.
     * Champ technique mise à jour automatiquement (par trigger)
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private String label;

    /**
     * le label du lot d'origine, recopié depuis BATCH.LABEL
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * le label du lot d'origine, recopié depuis BATCH.LABEL
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 12 associations
    private Method weightMethod;

    /**
     * Les méthodes sont rassemblées dans une liste qui couvre tous les domaines pour lesquels il
     * existe un
     * paramètre.
     * La liste des méthodes est générique et porte sur toutes les phases du processus de mesure des
     * paramètres. Chaque méthode n'est pas non plus systématiquement spécifique à l'une de ces
     * phases ou à
     * une nature particulière de paramètre. En effet, une méthode peut couvrir tout le cycle du
     * processus
     * et/ou être utilisable pour une phase quelle que soit la nature du paramètre.
     * Les méthodes peuvent être référencées par les paramètres à différentes phases de leur
     * processus de
     * mesure que sont :
     * pour les paramètres biologique :
     * - le prélèvement et l'échantillonnage ;
     * - la conservation et le transport ;
     * - le fractionnement ;
     * - l'analyse ;
     * pour les paramètres environnementaux :
     * - l'observation ;
     * @return this.weightMethod Method
     */
    public Method getWeightMethod()
    {
        return this.weightMethod;
    }

    /**
     * Les méthodes sont rassemblées dans une liste qui couvre tous les domaines pour lesquels il
     * existe un
     * paramètre.
     * La liste des méthodes est générique et porte sur toutes les phases du processus de mesure des
     * paramètres. Chaque méthode n'est pas non plus systématiquement spécifique à l'une de ces
     * phases ou à
     * une nature particulière de paramètre. En effet, une méthode peut couvrir tout le cycle du
     * processus
     * et/ou être utilisable pour une phase quelle que soit la nature du paramètre.
     * Les méthodes peuvent être référencées par les paramètres à différentes phases de leur
     * processus de
     * mesure que sont :
     * pour les paramètres biologique :
     * - le prélèvement et l'échantillonnage ;
     * - la conservation et le transport ;
     * - le fractionnement ;
     * - l'analyse ;
     * pour les paramètres environnementaux :
     * - l'observation ;
     * @param weightMethodIn Method
     */
    public void setWeightMethod(Method weightMethodIn)
    {
        this.weightMethod = weightMethodIn;
    }

    private Sale sale;

    /**
     * Vente liée à un navire, effectuée en un lieu et une date données. Une vente regroupe
     * plusieurs
     * produits vendus (Produce).
     * Attention : une vente est ponctuelle dans le temps. Si l'on souhaite recencer une vente qui
     * s'étale
     * sur plusieurs jours,
     * @return this.sale Sale
     */
    public Sale getSale()
    {
        return this.sale;
    }

    /**
     * Vente liée à un navire, effectuée en un lieu et une date données. Une vente regroupe
     * plusieurs
     * produits vendus (Produce).
     * Attention : une vente est ponctuelle dans le temps. Si l'on souhaite recencer une vente qui
     * s'étale
     * sur plusieurs jours,
     * @param saleIn Sale
     */
    public void setSale(Sale saleIn)
    {
        this.sale = saleIn;
    }

    private TaxonGroup inheritedTaxonGroup;

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @return this.inheritedTaxonGroup TaxonGroup
     */
    public TaxonGroup getInheritedTaxonGroup()
    {
        return this.inheritedTaxonGroup;
    }

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @param inheritedTaxonGroupIn TaxonGroup
     */
    public void setInheritedTaxonGroup(TaxonGroup inheritedTaxonGroupIn)
    {
        this.inheritedTaxonGroup = inheritedTaxonGroupIn;
    }

    private TaxonGroup calculatedTaxonGroup;

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @return this.calculatedTaxonGroup TaxonGroup
     */
    public TaxonGroup getCalculatedTaxonGroup()
    {
        return this.calculatedTaxonGroup;
    }

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @param calculatedTaxonGroupIn TaxonGroup
     */
    public void setCalculatedTaxonGroup(TaxonGroup calculatedTaxonGroupIn)
    {
        this.calculatedTaxonGroup = calculatedTaxonGroupIn;
    }

    private ReferenceTaxon inheritedReferenceTaxon;

    /**
     * 
     * @return this.inheritedReferenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getInheritedReferenceTaxon()
    {
        return this.inheritedReferenceTaxon;
    }

    /**
     * 
     * @param inheritedReferenceTaxonIn ReferenceTaxon
     */
    public void setInheritedReferenceTaxon(ReferenceTaxon inheritedReferenceTaxonIn)
    {
        this.inheritedReferenceTaxon = inheritedReferenceTaxonIn;
    }

    private Collection<DenormalizedBatch> childBatchs = new HashSet<DenormalizedBatch>();

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @return this.childBatchs Collection<DenormalizedBatch>
     */
    public Collection<DenormalizedBatch> getChildBatchs()
    {
        return this.childBatchs;
    }

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @param childBatchsIn Collection<DenormalizedBatch>
     */
    public void setChildBatchs(Collection<DenormalizedBatch> childBatchsIn)
    {
        this.childBatchs = childBatchsIn;
    }

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @param elementToAdd DenormalizedBatch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addChildBatchs(DenormalizedBatch elementToAdd)
    {
        return this.childBatchs.add(elementToAdd);
    }

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @param elementToRemove DenormalizedBatch
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeChildBatchs(DenormalizedBatch elementToRemove)
    {
        return this.childBatchs.remove(elementToRemove);
    }

    private DenormalizedBatch parentBatch;

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @return this.parentBatch DenormalizedBatch
     */
    public DenormalizedBatch getParentBatch()
    {
        return this.parentBatch;
    }

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @param parentBatchIn DenormalizedBatch
     */
    public void setParentBatch(DenormalizedBatch parentBatchIn)
    {
        this.parentBatch = parentBatchIn;
    }

    private Operation operation;

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @return this.operation Operation
     */
    public Operation getOperation()
    {
        return this.operation;
    }

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @param operationIn Operation
     */
    public void setOperation(Operation operationIn)
    {
        this.operation = operationIn;
    }

    private ReferenceTaxon referenceTaxon;

    /**
     * 
     * @return this.referenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    /**
     * 
     * @param referenceTaxonIn ReferenceTaxon
     */
    public void setReferenceTaxon(ReferenceTaxon referenceTaxonIn)
    {
        this.referenceTaxon = referenceTaxonIn;
    }

    private Collection<DenormalisedBatchSortingValue> denormalisedBatchSortingValues = new HashSet<DenormalisedBatchSortingValue>();

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @return this.denormalisedBatchSortingValues Collection<DenormalisedBatchSortingValue>
     */
    public Collection<DenormalisedBatchSortingValue> getDenormalisedBatchSortingValues()
    {
        return this.denormalisedBatchSortingValues;
    }

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @param denormalisedBatchSortingValuesIn Collection<DenormalisedBatchSortingValue>
     */
    public void setDenormalisedBatchSortingValues(Collection<DenormalisedBatchSortingValue> denormalisedBatchSortingValuesIn)
    {
        this.denormalisedBatchSortingValues = denormalisedBatchSortingValuesIn;
    }

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @param elementToAdd DenormalisedBatchSortingValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addDenormalisedBatchSortingValues(DenormalisedBatchSortingValue elementToAdd)
    {
        return this.denormalisedBatchSortingValues.add(elementToAdd);
    }

    /**
     * ATTENTION : Table technique. (RAZ des données possible)
     * @param elementToRemove DenormalisedBatchSortingValue
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeDenormalisedBatchSortingValues(DenormalisedBatchSortingValue elementToRemove)
    {
        return this.denormalisedBatchSortingValues.remove(elementToRemove);
    }

    private TaxonGroup taxonGroup;

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Indice qualité d'une donnée.
     * Actuellement, les indices qualités identifiés sont :
     * 0 - Non qualifiée,
     * 1 - Bonne,
     * 2 - Hors statistiques,
     * 3 - Douteuse,
     * 4 - Fausse,
     * 5 - Corrigée,
     * 8 - Incomplète,
     * 9 - Absente.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Indice qualité d'une donnée.
     * Actuellement, les indices qualités identifiés sont :
     * 0 - Non qualifiée,
     * 1 - Bonne,
     * 2 - Hors statistiques,
     * 3 - Douteuse,
     * 4 - Fausse,
     * 5 - Corrigée,
     * 8 - Incomplète,
     * 9 - Absente.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    /**
     * Returns <code>true</code> if the argument is an DenormalizedBatch instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DenormalizedBatch))
        {
            return false;
        }
        final DenormalizedBatch that = (DenormalizedBatch)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link DenormalizedBatch}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DenormalizedBatch}.
         * @return new DenormalizedBatchImpl()
         */
        public static DenormalizedBatch newInstance()
        {
            return new DenormalizedBatchImpl();
        }

        /**
         * Constructs a new instance of {@link DenormalizedBatch}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param rankOrder Short
         * @param flatRankOrder Short
         * @param treeLevel Short
         * @param isLanding Boolean
         * @param isDiscard Boolean
         * @param qualityFlag QualityFlag
         * @return newInstance
         */
        public static DenormalizedBatch newInstance(Short rankOrder, Short flatRankOrder, Short treeLevel, Boolean isLanding, Boolean isDiscard, QualityFlag qualityFlag)
        {
            final DenormalizedBatch entity = new DenormalizedBatchImpl();
            entity.setRankOrder(rankOrder);
            entity.setFlatRankOrder(flatRankOrder);
            entity.setTreeLevel(treeLevel);
            entity.setIsLanding(isLanding);
            entity.setIsDiscard(isDiscard);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DenormalizedBatch}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param rankOrder Short
         * @param flatRankOrder Short
         * @param weight Float
         * @param indirectWeight Float
         * @param elevateWeight Float
         * @param individualCount Integer
         * @param indirectIndividualCount Integer
         * @param elevateIndividualCount Integer
         * @param elevateContextWeight Float
         * @param indirectContextWeight Float
         * @param samplingRatio Float
         * @param samplingRatioText String
         * @param exhaustiveInventory Boolean
         * @param childBatchsReplication Boolean
         * @param comments String
         * @param treeLevel Short
         * @param treeIndent String
         * @param sortingValuesText String
         * @param isLanding Boolean
         * @param isDiscard Boolean
         * @param updateDate Timestamp
         * @param label String
         * @param remoteId Integer
         * @param weightMethod Method
         * @param sale Sale
         * @param inheritedTaxonGroup TaxonGroup
         * @param calculatedTaxonGroup TaxonGroup
         * @param inheritedReferenceTaxon ReferenceTaxon
         * @param childBatchs Collection<DenormalizedBatch>
         * @param parentBatch DenormalizedBatch
         * @param operation Operation
         * @param referenceTaxon ReferenceTaxon
         * @param denormalisedBatchSortingValues Collection<DenormalisedBatchSortingValue>
         * @param taxonGroup TaxonGroup
         * @param qualityFlag QualityFlag
         * @return newInstance DenormalizedBatch
         */
        public static DenormalizedBatch newInstance(Short rankOrder, Short flatRankOrder, Float weight, Float indirectWeight, Float elevateWeight, Integer individualCount, Integer indirectIndividualCount, Integer elevateIndividualCount, Float elevateContextWeight, Float indirectContextWeight, Float samplingRatio, String samplingRatioText, Boolean exhaustiveInventory, Boolean childBatchsReplication, String comments, Short treeLevel, String treeIndent, String sortingValuesText, Boolean isLanding, Boolean isDiscard, Timestamp updateDate, String label, Integer remoteId, Method weightMethod, Sale sale, TaxonGroup inheritedTaxonGroup, TaxonGroup calculatedTaxonGroup, ReferenceTaxon inheritedReferenceTaxon, Collection<DenormalizedBatch> childBatchs, DenormalizedBatch parentBatch, Operation operation, ReferenceTaxon referenceTaxon, Collection<DenormalisedBatchSortingValue> denormalisedBatchSortingValues, TaxonGroup taxonGroup, QualityFlag qualityFlag)
        {
            final DenormalizedBatch entity = new DenormalizedBatchImpl();
            entity.setRankOrder(rankOrder);
            entity.setFlatRankOrder(flatRankOrder);
            entity.setWeight(weight);
            entity.setIndirectWeight(indirectWeight);
            entity.setElevateWeight(elevateWeight);
            entity.setIndividualCount(individualCount);
            entity.setIndirectIndividualCount(indirectIndividualCount);
            entity.setElevateIndividualCount(elevateIndividualCount);
            entity.setElevateContextWeight(elevateContextWeight);
            entity.setIndirectContextWeight(indirectContextWeight);
            entity.setSamplingRatio(samplingRatio);
            entity.setSamplingRatioText(samplingRatioText);
            entity.setExhaustiveInventory(exhaustiveInventory);
            entity.setChildBatchsReplication(childBatchsReplication);
            entity.setComments(comments);
            entity.setTreeLevel(treeLevel);
            entity.setTreeIndent(treeIndent);
            entity.setSortingValuesText(sortingValuesText);
            entity.setIsLanding(isLanding);
            entity.setIsDiscard(isDiscard);
            entity.setUpdateDate(updateDate);
            entity.setLabel(label);
            entity.setRemoteId(remoteId);
            entity.setWeightMethod(weightMethod);
            entity.setSale(sale);
            entity.setInheritedTaxonGroup(inheritedTaxonGroup);
            entity.setCalculatedTaxonGroup(calculatedTaxonGroup);
            entity.setInheritedReferenceTaxon(inheritedReferenceTaxon);
            entity.setChildBatchs(childBatchs);
            entity.setParentBatch(parentBatch);
            entity.setOperation(operation);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setDenormalisedBatchSortingValues(denormalisedBatchSortingValues);
            entity.setTaxonGroup(taxonGroup);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DenormalizedBatch o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRankOrder().compareTo(o.getRankOrder()));
            }
            if (this.getFlatRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFlatRankOrder().compareTo(o.getFlatRankOrder()));
            }
            if (this.getWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getWeight().compareTo(o.getWeight()));
            }
            if (this.getIndirectWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndirectWeight().compareTo(o.getIndirectWeight()));
            }
            if (this.getElevateWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getElevateWeight().compareTo(o.getElevateWeight()));
            }
            if (this.getIndividualCount() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndividualCount().compareTo(o.getIndividualCount()));
            }
            if (this.getIndirectIndividualCount() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndirectIndividualCount().compareTo(o.getIndirectIndividualCount()));
            }
            if (this.getElevateIndividualCount() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getElevateIndividualCount().compareTo(o.getElevateIndividualCount()));
            }
            if (this.getElevateContextWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getElevateContextWeight().compareTo(o.getElevateContextWeight()));
            }
            if (this.getIndirectContextWeight() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getIndirectContextWeight().compareTo(o.getIndirectContextWeight()));
            }
            if (this.getSamplingRatio() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingRatio().compareTo(o.getSamplingRatio()));
            }
            if (this.getSamplingRatioText() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSamplingRatioText().compareTo(o.getSamplingRatioText()));
            }
            if (this.getExhaustiveInventory() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getExhaustiveInventory().compareTo(o.getExhaustiveInventory()));
            }
            if (this.getChildBatchsReplication() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getChildBatchsReplication().compareTo(o.getChildBatchsReplication()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getTreeLevel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTreeLevel().compareTo(o.getTreeLevel()));
            }
            if (this.getTreeIndent() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTreeIndent().compareTo(o.getTreeIndent()));
            }
            if (this.getSortingValuesText() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSortingValuesText().compareTo(o.getSortingValuesText()));
            }
            if (this.isIsLanding() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsLanding().compareTo(o.isIsLanding()));
            }
            if (this.isIsDiscard() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsDiscard().compareTo(o.isIsDiscard()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DenormalizedBatch.java merge-point
}