// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.location;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 *
 * @see LocationHierarchy
 */
public interface LocationHierarchyDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link LocationHierarchy}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of LocationHierarchy from the persistent store.
     * @param locationHierarchyPk
     * @return LocationHierarchy
     */
    public LocationHierarchy get(LocationHierarchyPK locationHierarchyPk);

    /**
     * <p>
     * Does the same thing as {@link #get(LocationHierarchyPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param locationHierarchyPk the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, LocationHierarchyPK locationHierarchyPk);

    /**
     * Loads an instance of LocationHierarchy from the persistent store.
     * @param locationHierarchyPk
     * @return LocationHierarchy
     */
    public LocationHierarchy load(LocationHierarchyPK locationHierarchyPk);

    /**
     * <p>
     * Does the same thing as {@link #load(LocationHierarchyPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param locationHierarchyPk the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, LocationHierarchyPK locationHierarchyPk);

    /**
     * Loads all entities of type {@link LocationHierarchy}.
     *
     * @return the loaded entities.
     */
    public Collection<LocationHierarchy> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of LocationHierarchy and adds it to the persistent store.
     * @param locationHierarchy
     * @return LocationHierarchy
     */
    public LocationHierarchy create(LocationHierarchy locationHierarchy);

    /**
     * <p>
     * Does the same thing as {@link #create(LocationHierarchy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param locationHierarchy
     * @return Object
     */
    public Object create(int transform, LocationHierarchy locationHierarchy);

    /**
     * Creates a new instance of LocationHierarchy and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of LocationHierarchy
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<LocationHierarchy> create(Collection<LocationHierarchy> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(LocationHierarchy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<LocationHierarchy> entities);

    /**
     * <p>
     * Creates a new <code>LocationHierarchy</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param childSurfaceRatio Ratio de couverture (en surface) du lieu fils par rapport au lieu père. La valeur doit etre
supérieure strictement à 0 et inférieur ou égale à 1.
Déduit à partir de la valeur de  LocationAssociation.childSurfaceRatio, selon un algorithme de
parcours d'arbre (cf procedure stockée P_FILL_LOCATION_HIERARCHY)
     * @param isMainAssociation <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Indique si l'association est considérée comme la principale.
</p>
<p>
Dans le cas d'une zone en mer rattachée à plusieurs zones parente, cela
permet de de récupérer qu'une seule zone (utiliser notamment pour le&#160;SIG
SIH)
</p>
</body>
</html>
     * @return LocationHierarchy
     */
    public LocationHierarchy create(
        Float childSurfaceRatio,
        Boolean isMainAssociation);

    /**
     * <p>
     * Does the same thing as {@link #create(Float, Boolean)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param childSurfaceRatio Ratio de couverture (en surface) du lieu fils par rapport au lieu père. La valeur doit etre
supérieure strictement à 0 et inférieur ou égale à 1.
Déduit à partir de la valeur de  LocationAssociation.childSurfaceRatio, selon un algorithme de
parcours d'arbre (cf procedure stockée P_FILL_LOCATION_HIERARCHY)
     * @param isMainAssociation <html>
<head>
<style>
p {padding:0px; margin:0px;}
</style>
</head>
<body>
<p>
Indique si l'association est considérée comme la principale.
</p>
<p>
Dans le cas d'une zone en mer rattachée à plusieurs zones parente, cela
permet de de récupérer qu'une seule zone (utiliser notamment pour le&#160;SIG
SIH)
</p>
</body>
</html>
     * @return LocationHierarchy
     */
    public Object create(
        int transform,
        Float childSurfaceRatio,
        Boolean isMainAssociation);

    /**
     * <p>
     * Creates a new <code>LocationHierarchy</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param childSurfaceRatio
     * @param isMainAssociation
     * @param location
     * @param parent
     * @return LocationHierarchy
     */
    public LocationHierarchy create(
        Float childSurfaceRatio,
        Boolean isMainAssociation,
        Location location,
        Location parent);

    /**
     * <p>
     * Does the same thing as {@link #create(Float, Boolean)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param childSurfaceRatio
     * @param isMainAssociation
     * @param location
     * @param parent
     * @return Object
     */
    public Object create(
        int transform,
        Float childSurfaceRatio,
        Boolean isMainAssociation,
        Location location,
        Location parent);

    /**
     * Updates the <code>locationHierarchy</code> instance in the persistent store.
     * @param locationHierarchy
     */
    public void update(LocationHierarchy locationHierarchy);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<LocationHierarchy> entities);

    /**
     * Removes the instance of LocationHierarchy from the persistent store.
     * @param locationHierarchy
     */
    public void remove(LocationHierarchy locationHierarchy);

    /**
     * Removes the instance of LocationHierarchy having the given
     * <code>identifier</code> from the persistent store.
     * @param locationHierarchyPk
     */
    public void remove(LocationHierarchyPK locationHierarchyPk);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<LocationHierarchy> entities);

    /**
     * 
     * @param id 
     * @param fatherId 
     * @return LocationHierarchy
     */
    public LocationHierarchy findLocationHierarchyByIdentifiers(Integer id, Integer fatherId);

    /**
     * 
     * @param id 
     * @return Collection
     */
    public Collection findLocationHierarchiesById(Integer id);

    /**
     * 
     * @param fatherId 
     * @return Collection
     */
    public Collection findLocationHierarchiesByFatherId(Integer fatherId);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<LocationHierarchy> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.technical.optimization.location.LocationHierarchyDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.technical.optimization.location.LocationHierarchyDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final LocationHierarchy entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,LocationHierarchy)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.technical.optimization.location.LocationHierarchyDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,LocationHierarchy)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}